@echo off
setlocal EnableDelayedExpansion
color 3f

Title 黑域补丁一键制作
echo.
echo             = ##^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^## =
echo             = ##              黑域补丁一键制作              ## =
echo             = ##                                            ## =
echo             = ##                NEVER SETTLE                ## =
echo             = ##                                            ## =
echo             = ##  The tool comes from OnePlus Community     ## =
echo             = ##                By  HellxZ                  ## =
echo                 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
echo.
echo                              ====  提醒  ====
echo.
echo          - 1、确保工作路径为D:\hellxz\黑域补丁一键制作.bat
echo          - 2、已合并odex的services.jar文件（大于1M）放在D:\hellxz\jar\下.
echo          - 3、未合并odex的services.odex和boot.oat放在D:\hellxz\odex\下.
echo          - 4、合并与未合并区分方法，re管理器system/framework下有没有文件夹
echo               有文件夹的是未合并的，无文件夹是合并的，请注意！
echo          - 5、确保你电脑装了python环境和java环境，并都能成功运行.
echo          - 6、本工具支持自动清除临时文件，请勿随意删除文件夹
echo          - 6、特别注意：此工具不支持安卓4.4未合并odex的补丁制作.
echo.
pause
cls
goto menu

:menu
@echo off
Title 黑域补丁一键制作
echo.
echo.
echo.
echo              #^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^#
echo              #                菜单                 #
echo              #^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^#
echo.
echo.
echo              请输入对应数字进行操作！
echo.
echo.
echo              1) 合并了odex的jar补丁制作（无文件夹）
echo.                                                                                  
echo              2) 6.0-7.1未合并odex的jar补丁制作（有文件夹）
echo.
echo              3) 5.0-5.1未合并odex的jar补丁制作（有文件夹）
echo.
echo              4) 去一加社区我的帖子看看
echo.
echo              0) 退出此界面并关闭工具
echo.
echo.
set /p choice= 输入数字操作:
echo.
if '%choice%'=='1' goto hellxz1
if '%choice%'=='2' goto hellxz2
if '%choice%'=='3' goto hellxz3
if '%choice%'=='4' goto hellxz4
if '%choice%'=='0' goto Exitstop00


:hellxz1
echo.
ECHO.开始制作ing，请稍候...
echo   1、把 services 转成 smali
echo.
java -Xms1g -jar baksmali-2.2b4.jar d D:\hellxz\jar\services.jar -o services
echo.
echo   2、把 apk 转成 smali
echo.
java -Xms1g -jar baksmali-2.2b4.jar d D:\hellxz\hy.apk -o apk
echo.
echo   3、正在打补丁
echo.
python D:\hellxz\patch.py -a apk -s services
echo.
echo   4、正在输出打过补丁的 services.jar
echo.
java -Xms1g -jar smali-2.2b4.jar a -o classes.dex services
jar -cvf services.jar classes.dex
echo.
echo   制作成功！生成的services.jar在D:\hellxz\services.jar
echo.
echo   正在清理临时文件，请稍候...
if exist services rd /s/q services
if exist classes.dex del /q classes.dex
if exist apk rd /s/q apk
echo   清理临时文件成功
echo.
echo   请按任意键关闭此窗口
echo.
pause >nul
cls
adb.exe kill-server
cls
exit

:hellxz2
echo.
ECHO. 开始制作ing，请稍候...
echo   1、把 services 转成 smali
echo.
java -Xms1g -jar baksmali-2.2b4.jar x -d D:\hellxz\odex D:\hellxz\odex\services.odex -o services
echo.
echo   2、把 apk 转成 smali
echo.
java -Xms1g -jar baksmali-2.2b4.jar d D:\hellxz\hy.apk -o apk
echo.
echo   3、正在打补丁
echo.
python D:\hellxz\patch.py -a apk -s services
echo.
echo   4、正在输出打过补丁的 services.jar
echo.
java -Xms1g -jar smali-2.2b4.jar a -o classes.dex services
jar -cvf services.jar classes.dex
echo.
echo   制作成功！生成的services.jar在D:\hellxz\services.jar
echo.
echo   正在清理临时文件，请稍候...
if exist services rd /s/q services
if exist classes.dex del /q classes.dex
if exist apk rd /s/q apk
echo   清理临时文件成功！
echo.
echo   请按任意键关闭此窗口
echo.
pause >nul
cls
adb.exe kill-server
cls
exit

:hellxz3
echo.
ECHO.  开始制作ing，请稍候...
echo   1、把 services 转成 smali
echo.
java -Xms1g -jar oat2dex.jar boot D:\hellxz\odex\boot.oat 
java -Xms1g -jar oat2dex.jar D:\hellxz\odex\services.odex D:\hellxz\odex\dex
java -Xms1g -jar baksmali-2.2b4.jar d D:\hellxz\odex\services.dex -o services
echo.
echo   2、把 apk 转成 smali
echo.
java -Xms1g -jar baksmali-2.2b4.jar d D:\hellxz\hy.apk -o apk
echo.
echo   3、正在打补丁
echo.
python D:\hellxz\patch.py -a apk -s services
echo.
echo   4、正在输出打过补丁的 services.jar
echo.
java -Xms1g -jar smali-2.2b4.jar a -o classes.dex services
jar -cvf services.jar classes.dex
echo.
echo   制作成功！生成的services.jar在D:\hellxz\services.jar
echo.
echo   正在清理临时文件，请稍候...
if exist services rd /s/q services
if exist classes.dex del /q classes.dex
if exist apk rd /s/q apk
echo.
echo   清理临时文件成功
echo.
echo   请按任意键关闭此窗口
echo.
pause >nul
cls
adb.exe kill-server
cls
exit

:hellxz4
start http://www.oneplusbbs.com/thread-3073343-1-1.html
cls
goto menu

:Exitstop00
echo.
adb.exe kill-server
cls
exit